commit 0a4b21e33b3db9c07c0a9eb7e322d5201728e796
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-02-03
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-02-03

    makerelease: Provide ANDROID_HOME from outside

commit 85cd65a6644a1ed1e75f14868f6b6e40983fdf8d
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-02-02
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-02-02

    Add debug log for aligned cache write

commit 13975f66a264a5e953729cb5e9e6227389fd44fc
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-02-02
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-02-02

    test: Add missing filelist2.txt to EXTRA_DIST

commit b9ee9a1195a790c07dc50a60696b78c556c177d8
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-02-02
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-02-02

    doc: Customize theme

commit 561f0b3e29d0f09f5e64ec9923a4d9627231fa89
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-22
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-02-01

    Use std::deque instead of std::list in IndexedList
    
    We choose faster iteration over rare slower deletion in the middle.

commit 643e7222b081c208327a662836a9fa6433c94cb8
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-29
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-29

    Update NEWS

commit 1639ca5b5b54492f3fddd68078fe929d025363c2
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-29
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-29

    Update bash_completion

commit a5034817011949afe767b037fae08475e7b0cf90
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-29
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-29

    Bump up version number to 1.16.2

commit de9697fc47ad223dc4ac6e5c6c5767ed0f24c09b
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-29
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-29

    Fix compiler warning

commit e5837171448d6b07649ad5bd99313c65549b0bc5
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-28
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-28

    Increase MAX_PEER_LIST_SIZE to 512
    
    We definitely need some tests to determine this value.

commit f8cb9b67de8045717ff3e5ac503f17fc87107190
Author:     ITriskTI <ITriskTI@gmail.com>
AuthorDate: 2013-01-27
Commit:     ITriskTI <ITriskTI@gmail.com>
CommitDate: 2013-01-27

    Update and fixed some bugs

commit 382cb9a19128fd57dee0c4b7596d45dacbdf6808
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-27
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-27

    Document about k and m can be used as well as K and M.

commit 988878930e50dcca7ac3a3d63cb0410080c6dbd3
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-27
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-27

    Check SSL_OP_NO_COMPRESSION is available before using it

commit a722500d62010b80d9ce5af91b11755a7d31589b
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-26
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-26

    Make DefaultPeerStorage::droppedPeers_ distinct

commit 3a19b65dd77ff7a71c8ad277ec9ba3e17de7ee2d
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-26
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-26

    Rename /BadCondition/ in Peer to /Drop/

commit 91b26ab2a8c252c36d3cd7bfd48fe7d622e443f3
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-26
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-26

    DefaultPeerStorage::addBadPeer: Updating eoi is not required after erasure

commit 1e4f301ec1d64ada5926facb0115d029c2995c38
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-26
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-26

    Remove PeerStorage::getActivePeers() and add getUsedPeers() instead
    
    PeerStorage::getUsedPeers() returns non-active peers, so caller must
    call Peer::isActive() to get active peers.

commit ba69f5c0c318132bb95c561f89488c754341ee96
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-26
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-26

    Refactor peer list management in DefaultPeerStorage
    
    Peer list is now divided into 2: unusedPeers_ and usedPeers_.
    Duplicate check is done using std::set by comparing pair of IP address
    and port. For this, only IP address and port given to the Peer
    constructor are used. In other words, TCP port received from extended
    message is not used for this purpose.

commit 8524ac38067ba2ca2e692de39166edd6612e1d5b
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-24
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-25

    Code cleanup

commit de394bbf615baf0a15b4c8b53c09b94ac274f3af
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-25
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-25

    DefaultPeerStorage::addPeer: Remove unnecessary '='

commit 550ac8c074c809865b349aba26080f68e3301696
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-25
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-25

    Fix bug returnPeer is not called if sequence_ == INITIATOR_SEND_KEY
    
    In InitiatorMSEHandshakeCommand, when aborting connection, we must
    return peer to the PeerStorage. But it is not done if sequence_ is
    INITIATOR_SEND_KEY. This causes stale Peer objects whose usedBy()
    returns true eventually occupies peer list and aria2 cannot make any
    connections.

commit 32a3c441af1f7554a5a8d2fbb3a4f742e741fc2b
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-24
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-24

    Fix bug: wrong parenthesis position in the condition

commit 3b7566faf118510768d16912ecb47ce991495cdc
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-16
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-16

    Rewritten util::uitos()

commit 1c72b80aa53673ea9fda0012bf3dadf77ae76b30
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-15
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-15

    Revert 53dde0a9
    
    Reverted to the original strategy, but some values are tweaked.
    Without TCP_NODELAY, 53dde0a9 does not work well.

commit bf4ea63a6692719344580dc33fd9113506d0027c
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-15
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-15

    Disable TCP_NODELAY for BitTorrent
    
    To make Request messages more often packed into 1 packet.

commit e6b027468567e7005170ba9ef7d7bc0ac67d031b
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-15
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-15

    Remove reqNumToCreate constraint when creating request
    
    It really degrades download speed.

commit df0be5e7f0f8ad54a684f7c62652283feedac034
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-15
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-15

    Cosmetic change

commit 88580da587523998e15caa27c5a988b00f22fa9f
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-15
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-15

    Remove Append and StringAppend

commit 6a976a4118b230eb3f579965f300cec8c9f2e1e0
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-15
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-15

    Accept k and m as well as K and M in util::getRealSize()

commit 851eb137c1d77b59ba6504ff666286840e63fc8f
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-15
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-15

    Reverted UB_MAX_OUTSTANDING_REQUEST to 256

commit 53dde0a9ae9c7de73214d5f27239c57881b218c6
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-15
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-15

    Download rate based strategy to increase outstanding request
    
    This strategy performs better than old one in high latency
    environment.

commit 2e216a94034da4fae47f79b5c614f7866aa2aac6
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-14
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-14

    Fix unit test error

commit d05ef28104d4d6b01a1a1a1087fcc65b5bc5b8db
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-14
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-14

    Avoid tiny packet for Have and Request message

commit d8f5887bbe7bc0ca31c37ed1bdc3a37431ca26b7
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-14
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-14

    Increase amount to 24K to pack Piece header and payload; fix missing goto

commit 63b6075c91ffe175ba5c89d33778a3ff1f1c2972
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-14
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-14

    Pack Piece message header and body into one chunk

commit 36fcccbbdf601a59a176fe7b90eaf3a2cbc120cc
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-11
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-11

    Reverted accidental change to CHOKE_ROUND_INTERVAL

commit 1ad815061b5c8d54c7288407eff7f63db4f36c63
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-11
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-11

    Rewritten SpeedCalc

commit c893d8286779533bfd652c6de8394cf32f4ca835
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-11
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-11

    Removed BtMessage::isSendingProgress()
    
    DefaultBtMessageDispatcher::isSendingInProgress() now checks the
    number of buffer entry in PeerConnection.

commit c04df672d190a320fc7583442a3a405da3a673c7
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-11
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-11

    Buffer up at most A2_IOV_MAX buffer entries for BtMessages

commit e0ea88ebcf71674ab4f56ae542f0f556cd1f434d
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-11
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-11

    mingw32: Make NTFS sparse file on --file-allocation=trunc

commit 357e4b1a77132705432345e0f54ec50ab07a73ab
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-11
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-11

    Made SocketCore::readData() and readDataFrom() take void*

commit 8ba0d58ee1a9fc2249839339549293ddc183fe66
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-11
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-11

    Vectorized write for SocketBuffer to avoid small packet

commit 74e570de379752508d7f363dd0d1a0c4ae8b7319
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-10
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-10

    Documented --save-session-interval option in man page

commit 8e63bad2da930c80d8f049376e61bd7152038ced
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-10
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-10

    Added --save-session-interval option
    
    --save-session-interval option saves error/unfinished downloads to a
    file specified by --save-session option every SEC seconds. If 0 is
    given, file will be saved only when aria2 exits.

commit 794f7b7014bc7e28c3436a7923d66365f238ee12
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-08
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-08

    Documented --referer="*" in man page

commit 87af7c32c6a982f0319a34c9a9b609b45684a766
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-08
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-08

    Use request URI as referer if --referer="*" is given

commit 58c047a4a80c634f4dce214deb0cd565a228e370
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-08
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-08

    Documented --console-log-level option in man page

commit 08bed3f77f03786febec3adcedc361e399367cd6
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-07
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-07

    Log warn if unknown option is found in config file or -i file

commit d6000024c0998df64895f2fd4c0f7458ea07a8f3
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2013-01-05
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2013-01-05

    Added --console-log-level option
    
    --console-log-level option sets log level to output to console.
